/********************************** (C) COPYRIGHT *********************************
* File Name          : CH395FTPINC
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395FTPINCͷļ
**********************************************************************************/
#ifndef __FTPINC_H__
#define __FTPINC_H__
#define DEBUG            1                                   /*   22.1184Mhz115200*/
typedef struct _FTP
{
  UINT8 TcpStatus;                                           /* TCP״̬*/
    UINT8 CmdStatus;                                         /* ӿִ״̬*/
  UINT8 InterCmdS;                                           /* ӿִб־λ*/
  UINT8 CmdFirtS;                                            /* һִб־λ*/
  UINT8 FindList;                                            /* ҵָļ*/
  UINT8 FindFile;                                            /* ҵָļ*/
  UINT8 CmdDataS;                                            /* ״̬*/
  UINT8 SocketCtl;                                           /* ftpsocket*/
  UINT8 DatMonitor;                                          /* ftpsocket*/
  UINT8 DatTransfer;                                         /* ftpӴsocket*/
  UINT8 FileCmd;                                             /* ӿ  */
  UINT16 SouPort;                                            /* ˿ں*/
  UINT16 RecDatLen;                                          /* յݳ*/
}FTP;
extern   char  ListName[24];                                 /* ڱĿ¼ */
extern   char  ListMdk[24];                                  /* ڱ´Ŀ¼*/
extern   char  FileName[24];                                 /* ڱļ*/
extern   char  SourIP[17];                                   /* ڱתַIPַ*/
extern  const UINT8 *pUserName;                              /* ½*/
extern  const UINT8 *pPassword;                              /* e-mail Ϊ½*/
/* TCP״̬ */
#define FTP_MACH_DISCONT               0x00                  /* TCPϿ*/
#define FTP_MACH_CONNECT               0x01                  /* TCP*/
/* ״̬ */
#define FTP_MACH_QUIT                  0x01                  /* ½ǰ*/
#define FTP_MACH_CLOSE                 0x02                  /* ½*/
/* ݴ״̬ */
#define FTP_MACH_SENDDATA              0x01                  /* Ҫ*/
#define FTP_MACH_RECEDATA              0x02                  /* Ҫ*/
#define FTP_MACH_DATAOVER              0x04                  /* ݴ*/
/* ӿִ״̬ */
#define FTP_MACH_LOGINSUC              0x01                  /* ¼ɹ*/
#define FTP_MACH_SEARCHSUC             0x02                  /* Ѱļ*/
#define FTP_MACH_GETSUC                0x04                  /* ļɹ*/
#define FTP_MACH_PUTSUC                0x08                  /* ϴļɹ*/
/*  ִй̱־λ */
#define FTP_MACH_FINDLIST              0x01                  /* ѰĿ¼־λ*/
#define FTP_MACH_FINDFILE              0x02                  /* Ѱļ־λ*/
#define FTP_MACH_GETFILE               0x04                  /* ļ־λ*/
#define FTP_MACH_MKDLIST               0x08                  /* Ŀ¼־λ*/
#define FTP_MACH_PUTFILE               0x10                  /* ϴļ־λ*/
/* ״̬Ϣ */ 
#define FTP_CHECK_NULL                 0x00                  /* ûźŷ򲻽зϢ˶*/ 
#define FTP_CHECK_SUCCESS              0x00                  /* Ϣȷ  */
#define FTP_COMMAND_SUCCESS            0x00                  /* ӿִгɹ*/
#define FTP_COMMAND_CONTINUE           0x01                  /* ӿִй*/
/* ӿ */
#define FTP_CMD_LOGIN                  0x01                  /* ¼*/
#define FTP_CMD_SEARCH                 0x02                  /* Ѱļ*/
#define FTP_CMD_GETFILE                0x03                  /* ļ*/
#define FTP_CMD_PUTFILE                0x04                  /* ϴļ*/
/* *********************************************************************************************************************
* źź˶Դ
************************************************************************************************************************/
#define FTP_ERR_LOGIN               0x20                     /* ¼*/
#define FTP_ERR_SEARCH              0x21                     /* Ѱļ*/
#define FTP_ERR_GETFILE             0x22                     /* ļ*/
#define FTP_ERR_PUTFILE             0x23                     /* ϴļ*/
#define FTP_ERR_UNLIST        0x2a                           /* δҵĿ¼*/ 
#define FTP_ERR_UNFILE        0x2b                           /* δҵļ*/
#define FTP_ERR_UNKW        0x2f                             /* δ֪*/

void  CH395_FTPClientCmd( void );                            /* ѯ״ִ̬*/

void  CH395_FTPInterCmd( void );                             /* ִжӦеִ˳*/
 
void  CH395_SocketSendData( char *PSend, UINT32 Len,UINT8 index  ); /* */

void  CH395_FTPConnect( void );                               /* 563ʼ*/

void  CH395_FTPInitVari( void );                              /* ʼ*/
                  
void CH395_FTPProcessReceDat( char *recv_buff,UINT8 check_type,UINT8 socketid );/* ӦϢ*/

UINT8 CH395_FTPCmdRespond( char *recv_buff,UINT8 check_type );  /* ӦϢ*/

void  CH395_FTPCtlClient( UINT8 socketid);                      /* FTP*/

void CH395_FTPDatServer( UINT8 socketid,UINT16 *port );         /* FTP*/

void  CH395_FTPCommand( UINT8 choiceorder);                     /* ִжӦ*/

UINT8 CH395_FTPLogin( void );                                   /* ½ */ 
 
UINT8 CH395_FTPSearch(char *pListNAme,char *pFileName );        /* ļ*/

UINT8 CH395_FTPGetFile( char *pFileName );                      /* ļ*/

UINT8 CH395_FTPPutFile(char *pListNAme, char *pFileName);       /* ϴļ*/

UINT8 CH395_FTPFindFile( char *pReceiveData );                  /* ˶ļ*/

UINT8 CH395_FTPFindList( char *pReceiveData );                  /* ˶ļ*/

void  CH395_FTPGetSockeID( UINT8 socketid );                    /* ȡsocket*/

UINT8 CH395_FTPMkdirCheck( char *rece_buf);                     /* Ŀ¼ִ״̬*/

UINT8 CH395_FTPGetFileData( char *recv_buff );                  /* ȡص*/

void  CH395_FTPQuit( void );                                    /* ˳*/

UINT8 CH395_FTPWriteData ( char *recv_buff ,UINT16 len);

#endif  
