/********************************** (C) COPYRIGHT *******************************
* File Name          : CH395UART.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395оƬ UARTӵӲ V1.0
*                      
*******************************************************************************/

/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ    CH395оƬ
      TXD                  RXD
      RXD                  TXD       */
#define CH395_INT_WIRE             INT1                          /* ٶCH395INT#,δôҲͨѯж״̬ʵ */

#define UART_INIT_BAUDRATE         9600                          /* ĬͨѶ9600bps,ͨӲ趨ֱѡߵCH395ĬͨѶ */
#define UART_WORK_BAUDRATE         57600                         /* ʽͨѶ57600bps */


/*******************************************************************************
* Function Name  : mDelayuS
* Description    : ʱָ΢ʱ,ݵƬƵ,ȷ
* Input          : us---ʱʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mDelayuS(UINT8 us)
{
    while(us --);                                                    /* MCS51@24MHz */
}

/*******************************************************************************
* Function Name  : mDelaymS
* Description    : ʱָʱ,ݵƬƵ,ȷ
* Input          : ms---ʱʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mDelaymS(UINT8 ms)
{
    while(ms --) 
    {
        mDelayuS(250);
        mDelayuS(250);
        mDelayuS(250);
        mDelayuS(250);
    }
}

/*******************************************************************************
* Function Name  : CH395_PORT_INIT
* Description    : Ӳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_PORT_INIT(void)
{
    /* Ƭֻһ,ôֹͨϢ */
    SCON = 0x50;
    PCON = 0x80;
//  TL2 = RCAP2L = 0 - 18432000/32/UART_INIT_BAUDRATE;               /* 18.432MHz */
    TL2 = RCAP2L = 0 - 24000000/32/UART_INIT_BAUDRATE;               /* 24MHz */

    /* ͨӲ趨ֱѡߵCH395ĬͨѶ */
    TH2 = RCAP2H = 0xFF;
    T2CON = 0x34;                                                    /* ʱ2ڴڵĲʷ */
    RI = 0;
    
}

/*******************************************************************************
* Function Name  : Set_MCU_BaudRate
* Description    : õƬ
*                  ƬлʽͨѶ 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SetMCUBaudRate(void)                                
{
//  TL2 = RCAP2L = 0 - 18432000/32/UART_WORK_BAUDRATE;               /* 18.432MHz */
    TL2 = RCAP2L = 0 - 24000000/32/UART_WORK_BAUDRATE;               /* 24MHz */
    RI = 0;
}


/********************************************************************************
* Function Name  : xWriteCH395Cmd
* Description    : CH395д
* Input          : cmd 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH395Cmd(UINT8 cmd)                                      
{
    TI = 0;
    SBUF = SER_SYNC_CODE1;                                           /* ĵ1ͬ */
    while(TI == 0);
    TI = 0;
    SBUF = SER_SYNC_CODE2;                                           /* ĵ2ͬ */
    while(TI == 0);
    TI = 0;
    SBUF = cmd;                                                      /*  */
    while(TI == 0);
    RI = 0;                                                                 
}

/********************************************************************************
* Function Name  : xWriteCH395Data
* Description    : CH395д
* Input          : mdata 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void  xWriteCH395Data(UINT8 mdata)
{                                                                    /* CH395д */
    TI = 0;
    SBUF = mdata;                                                    /*  */
    while(TI == 0);
}

/********************************************************************************
* Function Name  : xReadCH395Data
* Description    : CH395
* Input          : None
* Output         : None
* Return         : 8λ
*******************************************************************************/
UINT8  xReadCH395Data(void)                                          /* CH395 */
{
    UINT32 i;
    
    for(i = 0; i < 500000; i ++) 
    {  
        /* ֹʱ */
        if(RI) 
        {  
            /* ڽյ */
            RI = 0;
            return(SBUF);                                            /*  */
        }
    }
    return(0);                                                       /* Ӧ÷ */
}

#define xEndCH395Cmd()     {}                                        /* SPIģʽЧ */

/**************************** endfile *************************************/
